------------------------------------------------------
--                                                  --
--       TEC - TipuaEnhancementCheck v 1.1.0        --
--                                                  --
--       Author: Bambusmjam - AntonidasEU           --
--                                                  --
------------------------------------------------------


SLASH_TEC1 = "/tec"

local flaskArray = {
        GetSpellInfo(188031), -- Flask of the Whispered Pact    (Intellect)
		GetSpellInfo(188033), -- Flask of the Seventh Demon     (Agility)
		GetSpellInfo(188034), -- Flask of the Countless Armies  (Strength)
		GetSpellInfo(188035) -- Flask of Ten Thousand Scars    (Stamina)
}
local runeArray = {
        GetSpellInfo(224001), -- Defiled Augmentation
}
local foodSmallArray = {
        225597, -- Crit Small
        225598, -- Haste Small
        225599, -- Mastery Small
        225600, -- Versatility Small
        225601, -- AOE Small
        
        225602, -- Crit Big
        225603, -- Haste Big
        225604, -- Mastery Big
        225605, -- Versatility Big
        225606 -- AOE Big
}
local foodBigArray = {
        225602, -- Crit Big
        225603, -- Haste Big
        225604, -- Mastery Big
        225605, -- Versatility Big
        225606 -- AOE Big
}

local function sendMsg( msg )

    if outputSetting == "off" then
    
        -- nothin
    
    elseif outputSetting == "self" then
    
        print(msg)
    
    elseif outputSetting == "party" then
    
        if IsInGroup() == true then
        
            if IsInRaid() == true  then
        
                SendChatMessage(msg , "RAID", nil, nil)
            
            else
            
                SendChatMessage(msg , "PARTY", nil, nil)
                
            end        
        
        else
            
            print(msg)
            return
        end
    
    elseif outputSetting == "guild" then
    
        SendChatMessage(msg , "GUILD", nil, nil)
    
    elseif outputSetting == "officer" then
    
        SendChatMessage(msg , "OFFICER", nil, nil)
    
    end

end

function configToDefault()
    
    if flaskSetting == nil then
    
        flaskSetting = true
        
    end
    
    if runeSetting == nil then
    
        runeSetting = false
        
    end
    
    if foodSetting == nil then
    
        foodSetting = "small"
        
    end
    
    if autoSetting == nil then
    
        autoSetting = false
        
    end
    
    if outputSetting == nil then
    
        outputSetting = "self"
        
    end
    
    if logSetting == nil then
    
        logSetting = true
        
    end
    
    if logArray == nil then
    
        logArray = {}
        
    end
    
    ButtonPrev:Disable()
    ButtonNext:Disable()
    
    tec_OnShow()
    
end

function outputSlider( value )

    if value == 0 then
    
        outputSetting = "off"
        OutputText:SetText("Output: off")
        
    elseif value == 1 then
    
        outputSetting = "self"
        OutputText:SetText("Output: self")
    
    elseif value == 2 then
        
        outputSetting = "party"
        OutputText:SetText("Output: party")
    
    elseif value == 3 then
        
        outputSetting = "guild"
        OutputText:SetText("Output: guild")
    
    elseif value == 4 then
    
        outputSetting = "officer"
        OutputText:SetText("Output: officer")
    
    end
end

function tec_OnShow()

    FlaskButton:SetChecked( flaskSetting )
    RuneButton:SetChecked( runeSetting )
    
    local bFood = true
    local bBig = true
    
    if foodSetting == "off" then
        
        bFood = false
        
    elseif foodSetting == "small" then
    
        bBig = false
    
    end
        
    FoodButton:SetChecked( bFood )
    
    if bFood == false then
        
        BigFoodButton:Hide()
    
    else
    
        BigFoodButton:Show()
        
    end
    
    BigFoodButton:SetChecked( bBig )	
	AutocheckButton:SetChecked( autoSetting )    
    LogButton:SetChecked( logSetting )
    
    if outputSetting == "off" then
        
        OutputSlider:SetValue(0)
        OutputText:SetText("Output: off")
    
    elseif outputSetting == "self" then
    
        OutputSlider:SetValue(1)
        OutputText:SetText("Output: self")
    
    elseif outputSetting == "party" then
    
        OutputSlider:SetValue(2)
        OutputText:SetText("Output: party")
    
    elseif outputSetting == "guild" then
    
        OutputSlider:SetValue(3)
        OutputText:SetText("Output: guild")
    
    elseif outputSetting == "officer" then
    
        OutputSlider:SetValue(4)
        OutputText:SetText("Output: officer")
    
    end

    updateChecklist()
    
end

function showsettings()

    print( "TEC Settings:")
    print( "Flaskcheck: " .. tostring(flaskSetting) )
    print( "Runecheck: " .. tostring(runeSetting) )
    print( "Foodcheck: " .. foodSetting )
    print( "Autocheck: " .. tostring(autoSetting) )
    print( "Output: " .. outputSetting )
    print( "Log: " .. tostring(logSetting) )
    

end

function showHelp ()

    print("TipuaEnhancementCheck Help")
    print("/tec check  - do a raidcheck")
    print("/tec flask [true/false] - set flaskcheck")
    print("/tec rune [true/false] - set runecheck")
    print("/tec food [big/small/false] - set foodcheck")
    print("/tec auto [true/false] - set autocheck")    
    print("/tec output [self/party/guild/officer/off] - set output channel")
    print("/tec log [true/false] - set log")
    print("/tec settings - shows active settings")
    print("/tec clear log - clears log")
    print("/tec summary - prints log summary")
    print("/tec summary [nr1] [nr2] - prints log summary from entry [nr1] to [nr2]")
    
end

function flask ( bFlask )
    
    flaskSetting = bFlask
    
    if bFlask == true then
        print("TipuaFlaskCheck on")
    elseif bFlask == false then
        print("TipuaFlaskCheck off")        
    end
    
end

function rune ( bRune )
    
    runeSetting = bRune
    
    if bRune == true then
        print("TipuaRuneCheck on")
    elseif bRune == false then
        print("TipuaRuneCheck off")        
    end
    
end

function food ( sFood )

    foodSetting = sFood
    
    if sFood == "big" then
        print("TipuaFoodCheck set to big")
    elseif sFood == "small" then
        print("TipuaFoodCheck set to small") 
    elseif sFood == "off" then
        print("TipuaFoodCheck off")          
    end
    
end

function logf ( sLog )

    logSetting = sLog
    
    if sLog == true then
        print("TEC log on")
    elseif sLog == false then
        print("TEC log off")        
    end
    
end

function raidcheck( encounterName )    
     
    iFlaskMissing = {}
    iRuneMissing = {}
    iFoodMissing = {}

    sendMsg("TEC Raidcheck: ")
    
    if logSetting == false and outputSetting == "off" then
    
        print("Log and output disabled. Cant check")
    
    else 
    
        if IsInGroup() == true then
        
            for i = 1, GetNumGroupMembers() do
            
                bFlask = false
                bRune = false
                bFood = false
                
                local name, _, subgroup, _, _, class = GetRaidRosterInfo(i) 
                
                name = gsub(name, "%-[^|]+", "")
                
                if flaskSetting == true then
                    
                    if getFlask(name) == false then
                        
                        table.insert( iFlaskMissing, name)
                        
                    end
                    
                end
                
                if runeSetting == true then
                    
                    if getRune(name) == false then
                        
                        table.insert( iRuneMissing, name)
                        
                    end
                    
                end
                
                if foodSetting ~= "off" then
                    
                    if getFood(name) == false then
                        
                        table.insert( iFoodMissing, name)
                        
                    end
                    
                end
                
            end
        
        else
        
            bFlask = false
            bRune = false
            bFood = false
            
            local playername = UnitName("player")
            
            if flaskSetting == true then
                    
                if getFlask(playername) == false then
                    
                    table.insert( iFlaskMissing, playername)
                    
                end
                    
            end
                
            if runeSetting == true then
                
                if getRune(playername) == false then
                    
                    table.insert( iRuneMissing, playername)
                    
                end
                
            end
                
            if foodSetting ~= "off" then
                
                if getFood(playername) == false then
                    
                    table.insert( iFoodMissing, playername)
                    
                end
                
            end
        
        end
        if flaskSetting == true then
        
            if table.getn( iFlaskMissing ) > 0 then
                
                local printString = "Missing Flasks: "
                
                for  i, _ in next, iFlaskMissing do
                    
                    if i == 1 then
                    
                        printString = printString .. iFlaskMissing[i]
                        
                    else
                        
                        printString = printString .. ", " .. iFlaskMissing[i]
                        
                    end
                    
                end
                
                sendMsg(printString)
            
            else
                
                sendMsg("No Flasks missing.")
            
            end
            
        end    
        
        if runeSetting == true then
            if table.getn( iRuneMissing ) > 0 then
                
                local printString = "Missing Runes: "
                
                for  i, _ in next, iRuneMissing do
                    
                    if i == 1 then
                    
                        printString = printString .. iRuneMissing[i]
                        
                    else
                        
                        printString = printString .. ", " .. iRuneMissing[i]
                        
                    end
                    
                end
                
                sendMsg(printString)
                
            else
                
                sendMsg("No Runes missing.")
                
            end
            
        end    
        
        if foodSetting ~= "off" then
        
            if table.getn( iFoodMissing ) > 0 then
                
                local printString = "Missing Food: "
                
                for  i, _ in next, iFoodMissing do
                    
                    if i == 1 then
                    
                        printString = printString .. iFoodMissing[i]
                        
                    else
                        
                        printString = printString .. ", " .. iFoodMissing[i]
                        
                    end
                    
                end
                
                sendMsg(printString)
                
            else
                
                sendMsg("No Food missing.")
                
            end
            
        end
        
        if logSetting == true then
            
            if encounterName == nil then
            
                encounterName = "Manual Check"
                
            end
        
            insertArray = { ["time"] = date(), ["encounter"] = encounterName, ["bFlask"] = flaskSetting, ["bRune"] = runeSetting, ["bFood"] = foodSetting, ["flask"]= iFlaskMissing, ["rune"]= iRuneMissing, ["food"]= iFoodMissing } 
            
            table.insert( logArray, insertArray)   
            
            updateChecklist()
            
            if outputSetting == "off" then
            
                print("TEC Check performed and saved")
                
            end
            
        end
        
    end
        
end

function getFlask( player )
    
    bReturn = false
    
    for _, flask in next, flaskArray do
    
        if UnitBuff(player, flask) then
            
            bReturn = true
                
        end
        
    end
    
    return bReturn
end

function getRune( player )
    
    bReturn = false
    
    for _, rune in next, runeArray do
    
        if UnitBuff(player, rune) then
            
            bReturn = true
                
        end
        
    end
    
    return bReturn
end

function getFood( player )
    
    bReturn = false
    
    local id = select( 11, UnitBuff( player, GetSpellInfo(19705) ))
    
    if id then
    
        if foodSetting == "small" then
        
            for _, food in next, foodSmallArray do
            
                if id == food then
                    
                    bReturn = true
                        
                end
                
            end
            
        elseif foodSetting == "big" then
        
            for _, food in next, foodBigArray do
            
                if id == food then
                    
                    bReturn = true
                    
                end
                
            end
            
        end
    
    end
    
    return bReturn
    
end

function updateChecklist()
    
    if logArray then
    
        currentPage = table.getn( logArray )
                
        showPage( currentPage, currentPage )
        
    end

end

function showPage( page, maxPages )

    ButtonPrev:Enable()
    ButtonNext:Enable() 

    if maxPages <= 1 then
        
        ButtonPrev:Disable()
        ButtonNext:Disable()   
        
    else
        
        if page == maxPages then
            
            ButtonNext:Disable()
            
        end
        
        if page == 1 then
        
            ButtonPrev:Disable()
            
        end
        
    end
    
    if page ~= 0 then
    
        CheckTitle:SetText( page .. " - " .. logArray[page]["time"] )   
        CheckTitleEncounter:SetText( logArray[page]["encounter"] )
        
        if logArray[page]["bFlask"] == true then
        
            FlaskTextTitle:SetText("Flask(ON):")
            FlaskTextTitle:SetTextColor(0, 1, 0)
            
            local flaskArray = logArray[page]["flask"]
            
            if table.getn( flaskArray ) > 0 then
            
                local printString = ""
                
                for  i, _ in next, flaskArray do
                    
                    if i == 1 then
                    
                        printString = printString .. flaskArray[i]
                        
                    else
                        
                        printString = printString .. ", " .. flaskArray[i]
                        
                    end
                    
                end
                
                FlaskTextList:SetText(printString)
                
            else
                
                FlaskTextList:SetText("No Flasks missing.")
                
            end
        
        else
        
            FlaskTextTitle:SetText("Flask(OFF):")
            FlaskTextTitle:SetTextColor(1, 0, 0)
            FlaskTextList:SetText("-")
        
        end
        
        if logArray[page]["bRune"] == true then
        
            RuneTextTitle:SetText("Rune(ON):")
            RuneTextTitle:SetTextColor(0, 1, 0)
            
            local runeArray = logArray[page]["rune"]
            
            if table.getn( runeArray ) > 0 then
            
                local printString = ""
                
                for  i, _ in next, runeArray do
                    
                    if i == 1 then
                    
                        printString = printString .. runeArray[i]
                        
                    else
                        
                        printString = printString .. ", " .. runeArray[i]
                        
                    end
                    
                end
                
                RuneTextList:SetText(printString)
                
            else
                
                RuneTextList:SetText("No Runes missing.")
                
            end
        
        else
        
            RuneTextTitle:SetText("Rune(OFF):")
            RuneTextTitle:SetTextColor(1, 0, 0)
            RuneTextList:SetText("-")
        
        end
        
        if logArray[page]["bFood"] == "big" then
        
            FoodTextTitle:SetText("Food(BIG):")
            FoodTextTitle:SetTextColor(0, 1, 0)
        
        elseif logArray[page]["bFood"] == "small" then
        
            FoodTextTitle:SetText("Food(SM):")
            FoodTextTitle:SetTextColor(1, 1, 0)
        
        elseif logArray[page]["bFood"] == "off" then
        
            FoodTextTitle:SetText("Food(OFF):")
            FoodTextTitle:SetTextColor(1, 0, 0)
            FoodTextList:SetText("-")
            
        end  

        if logArray[page]["bFood"] == "big" or logArray[page]["bFood"] == "small" then
        
            local foodArray = logArray[page]["food"]
            
            if table.getn( foodArray ) > 0 then
            
                local printString = ""
                
                for  i, _ in next, foodArray do
                    
                    if i == 1 then
                    
                        printString = printString .. foodArray[i]
                        
                    else
                        
                        printString = printString .. ", " .. foodArray[i]
                        
                    end
                    
                end
                
                FoodTextList:SetText(printString)
                
            else
                
                FoodTextList:SetText("No Food missing.")
                
            end
            
        end
    
    else 
    
        CheckTitle:SetText( "- - -" )
        CheckTitleEncounter:SetText("- - -")
        FlaskTextList:SetText("-")
        RuneTextList:SetText("-")
        FoodTextList:SetText("-")
        
    end

end

function nextPage( reverse )

    if reverse == false then
        
        currentPage = currentPage + 1
        
    else
    
        currentPage = currentPage - 1
        
    end
    
    showPage( currentPage, table.getn( logArray ) )
    
end

function getTableLength( t )

    count = 0

    for i, _ in next, t do
        
        count = count + 1
            
    end

    return count

end

function summary( arg1, arg2 )

	sumFlaskArray = {}
	sumRuneArray = {}
	sumFoodArray = {}
	
	for i = arg1, arg2, 1 do		
		
		if logArray[i]["bFlask"] == true then

			tempArray = logArray[i]
			
			for i, _ in next, tempArray["flask"] do
			
				sumName = tempArray["flask"][i]
				
				if sumFlaskArray[sumName] ~= nil then
				
					sumFlaskArray[sumName] = sumFlaskArray[sumName] + 1
				
				else
				
					sumFlaskArray[sumName] = 1
				
				end
				
			end
			
		end
		
		if logArray[i]["bRune"] == true then

			tempArray = logArray[i]
			
			for i, _ in next, tempArray["rune"] do
			
				sumName = tempArray["rune"][i]
				
				if sumRuneArray[sumName] ~= nil then
				
					sumRuneArray[sumName] = sumRuneArray[sumName] + 1
				
				else
				
					sumRuneArray[sumName] = 1
				
				end
				
			end
			
		end
		
		if logArray[i]["bFood"] ~= true then

			tempArray = logArray[i]
			
			for i, _ in next, tempArray["food"] do
			
				sumName = tempArray["food"][i]
				
				if sumFoodArray[sumName] ~= nil then
				
					sumFoodArray[sumName] = sumFoodArray[sumName] + 1
				
				else
				
					sumFoodArray[sumName] = 1
				
				end
				
			end
			
		end
		
	end	
	
	sumFlaskText = "Flasks: "
	sumRuneText = "Runes: "
	sumFoodText = "Food: "
    
    flaskArrayLength = getTableLength( sumFlaskArray )
    runeArrayLength = getTableLength( sumRuneArray )
    foodArrayLength = getTableLength( sumFoodArray )
    
    
    if flaskArrayLength > 0 then
        
        count = 0
    
        for i, _ in next, sumFlaskArray do
            
            count = count + 1
            
            if count < flaskArrayLength then
            
                sumFlaskText = sumFlaskText .. i .. "(" .. sumFlaskArray[i] .. "), "      
                
            else
            
                sumFlaskText = sumFlaskText .. i .. "(" .. sumFlaskArray[i] .. ")"   
                
            end
            
        end
    
    else

        sumFlaskText = sumFlaskText .. "-"
    
    end
    
    if runeArrayLength > 0 then
        
        count = 0
    
        for i, _ in next, sumRuneArray do
            
            count = count + 1
            
            if count < runeArrayLength then
            
                sumRuneText = sumRuneText .. i .. "(" .. sumRuneArray[i] .. "), "      
                
            else
            
                sumRuneText = sumRuneText .. i .. "(" .. sumRuneArray[i] .. ")"   
                
            end
            
        end
    
    else

        sumRuneText = sumRuneText .. "-"
    
    end
    
    if foodArrayLength > 0 then
        
        count = 0
    
        for i, _ in next, sumFoodArray do
            
            count = count + 1
            
            if count < foodArrayLength then
            
                sumFoodText = sumFoodText .. i .. "(" .. sumFoodArray[i] .. "), "      
                
            else
            
                sumFoodText = sumFoodText .. i .. "(" .. sumFoodArray[i] .. ")"   
                
            end
            
        end
    
    else

        sumFoodText = sumFoodText .. "-"
    
    end
    
    sendMsg("TEC Logsummary for entry " .. arg1 .. " to " .. arg2 .. ".")
	sendMsg(sumFlaskText)
    sendMsg(sumRuneText)
    sendMsg(sumFoodText)
	
end

function clearLog()
  
    logArray = {}
    
    print("TEC log cleared!")
    
    updateChecklist();

end

function deleteLog( nr )
	
	table.remove( logArray, nr)
   	updateChecklist()
	
end

SlashCmdList ["TEC"] = function (msg)
    local cmd, arg, arg2 = strsplit(" ",msg);
    
	if cmd == nil or strlen(cmd) < 1 then
        
        if TipuaEnhancementCheck:IsShown() then
        
            TipuaEnhancementCheck:Hide()
        
        else
        
            TipuaEnhancementCheck:Show()
        end
    
    elseif  cmd == "help" then
    
		showHelp()          
	
    elseif cmd == "check" then
    
        raidcheck()
        
    elseif cmd == "flask" then
        
        if arg == "true" then
        
            flask(true)   
            
        elseif arg == "false" then
        
            flask(false)    
            
        else
        
            print("Usage: /tec flask [true/false] - set flaskcheck")    
            
        end
        
    elseif cmd == "rune" then
    
        if arg == "true" then
        
            rune(true)
            
        elseif arg == "false" then
        
            rune(false)
            
        else 
        
            print("Usage: /tec rune [true/false] - set runecheck")
            
        end
    
    elseif cmd == "food" then
    
        if arg == "big" then
        
            food("big")
            
        elseif arg == "small" then
        
            food("small")
            
        elseif cmd == "food" and arg == "false" then
        
            food("off")
            
        else
        
            print("Usage: /tec food [big/small/false] - set foodcheck")
            
        end
    
    elseif cmd == "auto" then
    
        if arg == "true" then
            
            autoSetting = true            
            print("Autocheck on")
        
        elseif arg == "false" then
        
            autoSetting = false
            print("Autocheck off")
            
        else

            print("Usage: /tec auto [true/false] - set Autocheck")
        
        end
     
    elseif cmd == "output" then
        
        if arg == "self" then
            
            outputSetting = "self"            
            print("Output set to self")
        
        elseif arg == "party" then
        
            outputSetting = "party"            
            print("Output set to party")
        
        elseif arg == "guild" then
        
            outputSetting = "guild"            
            print("Output set to guild")
        
        elseif arg == "officer" then
        
            outputSetting = "officer"            
            print("Output set to officer")
        
        elseif arg == "off" then
        
            outputSetting = "off"            
            print("Output off")
        
        else

            print("Usage: /tec output [self/party/guild/officer/off] - set output channel")
        
        end       
    
    elseif cmd == "settings" then
    
        showsettings()
        
    elseif cmd == "log" then
    
        if arg == "true" then
        
            logf(true)
            
        elseif arg == "false" then
        
            logf(false)
            
        else 
        
            print("Usage: /tec log [true/false] - set log")
            
        end    
        
    elseif cmd == "clear" then
    
        if arg == "log" then
        
            clearLog()
            
        else
			
            print("Usage: /tec clear log - clears log")
            
        end
        
	elseif cmd == "delete" then
	
		if tonumber( arg ) ~= nil then
		
			if tonumber( arg ) <= table.getn( logArray ) then
			
				deleteLog( tonumber( arg ))
			
			else
				
				print("Error: Log Nr " .. arg .. " could not be found.")
				
			end
		
		else
			
			print("Usage: /tec delete [number]")
			
		end
		
	elseif cmd == "summary" then
	
		if outputSetting ~= "off" then
		
            if ( arg == nil ) and ( arg2 == nil ) then
            
                summary( 1, table.getn( logArray ))
            
            else
                if ( tonumber(arg) ~= nil ) and ( tonumber(arg2) ~= nil ) then
                    
                    summary( tonumber(arg), tonumber(arg2) )
                    
                else
                    
                    print("Usage: '/tec summary' or '/tec summary [nr] [nr]'")
                    
                end
                
            end
			
		else
		
			print("TEC: Cant print a summary since Outputsetting ist off.")
		
		end
		
    else
		
        showHelp()
        
    end
    
end


local frame = CreateFrame("FRAME", "FooAddonFrame");
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("ENCOUNTER_START")   
   
local function eventHandler(self, event, ...) 
    
    if event == "ENCOUNTER_START" then
    
        local encounterID, encounterName, difficultyID, raidSize = ...
        
        -- print(encounterID .. " . " .. encounterName .. " . " .. difficultyID .. " . " .. raidSize)
        
        if autoSetting == true  then   
                       
            raidcheck(encounterName)       
            
        end  
        
    elseif event == "ADDON_LOADED" then
        
        TipuaEnhancementCheck:Hide()
        configToDefault()            

    end
    
end
frame:SetScript("OnEvent", eventHandler);




